/*
 * Description : Kockadobos jatek. Bekerjuk a jatekosok szamat, majd az osszes
 *               jatekos dob a kockaval amit megjelenitunk, illetve kivalasztjuk
 *               a gyoztest aki osszesen a legtobbet dobta.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.21
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

enum {
       MINJATEKOS=3,
       MAXJATEKOS=6
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void) {
    char tmp[2+1];
    int i, eredmenyek[6], vege=0, jatekosdb, maximum=0, elso, masodik, harmadik;

    clrscr();
    randomize();

    printf("            -- Kockadobos jatek --           \n"
           "Kerem adja meg jatekosok szamat (min %d max %d):\n"
           "==============================================\n", MINJATEKOS, MAXJATEKOS);
    do {
        if (!getline(tmp, 2))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > 1)
            printf("Tul sok karakert adott meg!\n");
        else {
            if (!isdigit(tmp[0]))
                printf("Nem egesz szamot adott meg!\n");
            else {
                jatekosdb=atoi(tmp);
                if (jatekosdb < MINJATEKOS)
                    printf("Legalabb %d jatekos kell!\n", MINJATEKOS);
                else if (jatekosdb > MAXJATEKOS)
                    printf("Maximum %d jatszhatnak!\n", MAXJATEKOS);
                else
                    vege=1;
            }
        }
    } while (!vege);

    for (i=0; i<jatekosdb; ++i) {
        elso     = rand()%6+1;
        masodik  = rand()%6+1;
        harmadik = rand()%6+1;
        eredmenyek[i]=elso+masodik+harmadik;

        printf("A(z) %d. jatekos dobasai:\n"
               "========================\n"
               "Elso dobas         : %d\n"
               "Masodik dobas      : %d\n"
               "Harmadik dobas     : %d\n"
               "------------------------\n"
               "Osszeg: %d\n\n\n",i+1, elso, masodik, harmadik, eredmenyek[i]);

        if(eredmenyek[i] > maximum)
            maximum=eredmenyek[i];
    }

    printf("A legnagyobb dobas %d volt.\n", maximum);
    getch ();
}