/* newton.c */
#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#define PONTOSSAG 4  /* Az eredmny pontossgt befolysolja; rekurzv */
		     /* hvsok szma */
#define EPS .000001
#define MAX 128

double gyok1(double,int);
double gyok2(double);
double gyok3(double);
int getline(char[], int);
int lebege(char[]);

void main(void) {
  char sor[MAX+1];
  double szam;

  printf("Gykvons Newton mdszervel\nKilps EOF-ra vagy res sorra.\n");
  while (printf("\nSzm: "),getline(sor,MAX))
    if (lebege(sor)&&(szam=atof(sor))>=0) {
      printf("Ngyzetgyke %d lps utn (paramter):\t%.10lf\n",PONTOSSAG+1,gyok1(szam,PONTOSSAG));
      printf("Ngyzetgyke %d lps utn (statikus):\t%.10lf\n",PONTOSSAG+1,gyok2(szam));
      printf("Ngyzetgyk %f pontossggal:\t%.10lf",EPS,gyok3(szam));
    } else printf("Formailag hibs adat!");
}

double gyok1(double szam,int p) {
  double eredmeny;

  if (!p)
    return (1+szam)/2.;
  else
    return ((eredmeny=gyok1(szam,p-1))+szam/eredmeny)/2.;
}

double gyok2(double szam) {
  static int p=PONTOSSAG;
  double eredmeny;

  if (!p) {
    p=PONTOSSAG;
    return (1+szam)/2.;
  } else {
    p--;
    return ((eredmeny=gyok2(szam))+szam/eredmeny)/2.;
  }
}

double gyok3(double szam) {
  double x0=szam+1,x1;
  while(x1=(x0+szam/x0)/2.,x0-x1>EPS)
    x0=x1;
  return x1;
}

int getline(char s[],int lim) {
  int c,i;

  for (i=0;i<lim&&(c=getchar())!='\n'&&c!=EOF;++i) s[i]=c;
  s[i]='\0';
  while (c!=EOF&&c!='\n') c=getchar();
  return i;
}

int lebege(char *s){
  char *tmp;
  while(isspace(*s)) s++;
  if(*s=='+'||*s=='-') s++;
  tmp=s;
  while(isdigit(*s)) s++;
  if(*s=='.') s++;
  while(isdigit(*s)) s++;
  if(s==tmp||tmp+1==s&&*tmp=='.')return 0;
  if(*s=='E'||*s=='e'){
    s++;
    if(*s=='+'||*s=='-') s++;
    if(!isdigit(*s))return 0;
    while(isdigit(*s)) s++;}
  if(!*s||isspace(*s))return(1);
  else return(0); }