/*
 * Description : Az ANSI C szabvanyos tipusai es a szelekcio
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.21
 */
#include <stdio.h>
#include <limits.h>
#include <float.h>

void main(void) {
    /*
     * <elojel_modosito>(tipus)(valtozonev) = <kezdoertek>;
     */
    unsigned int egesz = 85;

    /****************************************
     * limits.h
     ****************************************
     * ASCII character (alapertelmezes szerint signed)
     */
    signed char   signed_char_min   = SCHAR_MIN;
    signed char   signed_char_max   = SCHAR_MAX;
    unsigned char unsigned_char_min = 0;
    unsigned char unsigned_char_max = UCHAR_MAX;

    /*
     * short int (alapertelmezes szerint signed)
     */
    signed short int   signed_short_int_min   = SHRT_MIN;
    signed short int   signed_short_int_max   = SHRT_MAX;
    unsigned short int unsigned_short_int_min = 0;
    unsigned short int unsigned_short_int_max = USHRT_MAX;

    /*
     * int (alapertelmezes szerint signed)
     */
    signed int   signed_int_min   = INT_MIN;
    signed int   signed_int_max   = INT_MAX;
    unsigned int unsigned_int_min = 0;
    unsigned int unsigned_int_max = UINT_MAX;

    /*
     * long int (alapertelmezes szerint signed)
     */
    signed long int   signed_long_int_min   = LONG_MIN;
    signed long int   signed_long_int_max   = LONG_MAX;
    unsigned long int unsigned_long_int_min = 0;
    unsigned long int unsigned_long_int_max = ULONG_MAX;

    /****************************************
     * float.h
     ****************************************
     * float (mindig signed)
     */
    float float_min = FLT_MIN;
    float float_max = FLT_MAX;

    /*
     * double (mindig signed)
     */
    double double_min = DBL_MIN;
    double double_max = DBL_MAX;

    /*
     * long double (mindig signed)
     */
    long double long_double_min = LDBL_MIN;
    long double long_double_max = LDBL_MAX;

    printf("AZ ANSI C tipusok hatarertekeinek kiiratasa:\n"
           "============================================\n");

    printf("signed   char min      : %11d\n"
           "signed   char max      : %11d\n"
           "unsigned char min      : %11d\n"
           "unsigned char max      : %11d\n\n", signed_char_min, signed_char_max, unsigned_char_min, unsigned_char_max);

    printf("signed short int   min : %11d\n"
           "signed short int   max : %11d\n"
           "unsigned short int min : %11d\n"
           "unsigned short int max : %11u\n\n", signed_short_int_min, signed_short_int_max, unsigned_short_int_min, unsigned_short_int_max);

    printf("signed int   min       : %11d\n"
           "signed int   max       : %11d\n"
           "unsigned int min       : %11d\n"
           "unsigned int max       : %11u\n\n", signed_int_min, signed_int_max, unsigned_int_min, unsigned_int_max);

    printf("signed long int   min  : %11li\n"
           "signed long int   max  : %11li\n"
           "unsigned long int min  : %11d\n"
           "unsigned long int max  : %11llu\n\n", signed_long_int_min, signed_long_int_max, unsigned_long_int_min, unsigned_long_int_max);

    printf("float min              : %14e\n"
           "float max              : %14e\n", float_min, float_max);

    printf("double min             : %14e\n"
           "double max             : %14e\n", double_min, double_max);

    printf("long double min        : %14e\n"
           "long double max        : %14e\n\n", long_double_min, long_double_max);

    /****************************************
     * SZELEKCIO
     ****************************************/
    printf("SZELEKCIO BEMUTATASA:\n"
           "=====================\n");

    printf("IF:\n"
           "---------------------\n");
    /* if */
    if (egesz > 100)
        printf("A szam nagyobb mint szaz.\n");

    printf("Vege az elso if-nek.\n\n");

    printf("IF - ELSE:\n"
           "---------------------\n");

    /* if - else */
    if (egesz > 100)
        printf("A szam nagyobb mint szaz.\n");
    else
        printf("A szam talsn kissebb mint szaz.\n");

    printf("Vege a masodik if-nek.\n\n");

    printf("IF - ELSE IF - ELSE:\n"
           "---------------------\n");

    /* if - else if - else */
    if (egesz > 100)
        printf("A szam nagyobb mint szaz.\n");
    else if (egesz < 100)
        printf("A szam kissebb mint szaz.\n");
    else
        printf("A szam pontosan 100.\n");

    printf("Vege a harmadik if-nek.\n\n");

    getch();
}