/*
 * Description : Az ANSI C tombjeinek es az iteracioinak a bemutatasa
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.21
 */
#include <stdio.h>
#include <string.h>

void main(void){
    /* ciklusvaltozok definialasa */
    int i = 0, j = 0, hossz = 0;
    /*
     * <modosito>tipus tombnev[<meret>] = <tomb_elemek>;
     * karakter tipusu tomb
     */
    char karakter_tomb[9] = "karakter";

    /****************************************
     * Igy helyezkednek el a memoriaban:
     * --------------------------------------
     * | k | a | r | a | k | t | e | r | \0 |
     * --------------------------------------
     *   0   1   2   3   4   5   6   7
     */

    /*
     * lebegopontos tipusu tomb
     */
    float lebegopontos_tomb[] = {1.2, 2.7, 3.4};

    /****************************************
     * Igy helyezkednek el a memoriaban:
     * -------------------
     * | 1.2 | 2.7 | 3.4 |
     * -------------------
     *    0     1     2
     */

    /*
     * egesz tipusu tomb
     */
    unsigned int egesz_tomb[] = {1, 2, 3, 4, 5, 6, 7};

    /****************************************
     * Igy helyezkednek el a memoriaban:
     * -----------------------------
     * | 1 | 2 | 3 | 4 | 5 | 6 | 7 |
     * -----------------------------
     *   0   1   2   3   4   5   6
     */

    /*
     * egesz tipusu ket dimenzios tomb (matrix)
     */
    signed int egesz_matrix[][4] = {{1, 2, 3, 4},
                                    {5, 6, 7, 8},
                                    {9}};

    /****************************************
     * Igy helyezkednek el a memoriaban:
     * -------------------------------------
     * | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 |
     * -------------------------------------
     *  0|0 0|1 0|2 0|3 1|0 1|1 1|2 1|3 2|0
     */

    /*
     * karakter tipusu tomb
     */
    char karakter_matrix[][6] = {"egy",
                                 "ketto",
                                 "harom"};

    /****************************************
     * Igy helyezkednek el a memoriaban:
     * ------------------------------------------------------------------------------
     * | e | g | y | \0 |    |    | k | e | t | t | e | \0 | h | a | r | o | m | \0 |
     * ------------------------------------------------------------------------------
     *  0|0 0|1 0|2                1|0 1|1 1|2 1|3 1|4      2|0 2|1 2|2 2|3 2|4
     */

    /****************************************
     * FOR CIKLUS
     ****************************************/
    printf("1. megoldas:\n"
           "------------\n");

    for (i=0; karakter_tomb[i]; ++i) {
        printf("%c", karakter_tomb[i]);
    }
    printf("\n");

    /* vagy */
    printf("2. megoldas:\n"
           "------------\n");

    for (i=0; karakter_tomb[i] != '\0'; ++i) {
        printf("%c", karakter_tomb[i]);
    }
    printf("\n");

    /* vagy */
    printf("3. megoldas:\n"
           "------------\n");

    for (i=0; i<strlen(karakter_tomb); ++i) {
        printf("%c", karakter_tomb[i]);
    }
    printf("\n");

    /* visszafele is mukodik */
    printf("Visszafele:\n"
           "------------\n");

    for (i=strlen(karakter_tomb)-1; i>=0; --i) {
        printf("%c", karakter_tomb[i]);
    }
    printf("\n");

    /* egyszeru kiiratasi modszer CSAK KARAKTER tipusu tombokhoz */
    printf("Egyszerubben:\n"
           "------------\n"
           "%s\n\n", karakter_tomb);

    /****************************************
     * WHILE CIKLUS
     ****************************************/
    i=0;
    printf("Szam tipusu tomb tartalma:\n"
           "--------------------------\n");
    while (i++ < 7) {
        printf("%d", egesz_tomb[i]);
    }
    printf("\n");

    /*
     * inkrementacio: i++  ugyan az mint i = i + 1 vagy mint i += 1
     * dekrementacio: i--  ugyan az mint i = i - 1 vagy mint i -= 1
     * ---------------------
     * ha i = 5 es x = 6 akkor
     * ---------------------
     * postfix: i-- + x = 5 + 6 = 11
     * prefix : ++i + x = 4 + 6 = 10
     */

    /* ha nem tudjuk, hogy hany szamunk van eltarolva akkor ket lehetoseg:
     * 1, elmentjuk egy valtozoba, hogy aktualisan hany ertekunk van
     * 2, sizeof() operator hasznalata (minden tipusu tombnel)
     * tomb elmeinek szama -> sizeof(tomb)/sizeof(tomb[0])
     */

    i=0;
    printf("Tomb while 1:\n"
           "-------------\n");
    while (i++ < sizeof(egesz_tomb)/sizeof(egesz_tomb[0])) {
        printf("%d ", egesz_tomb[i]);
    }
    printf("\n");

    /*
     * Nem tul hatekony mivel a sizeof(egesz_tomb)/sizeof(egesz_tomb[0])
     * kiertekeleset minden ismetlesnel el kell vegezni, ezert
     */

    i=0;
    printf("Tomb while 2:\n"
           "-------------\n");
    /* a hossz mentese */
    hossz = sizeof(egesz_tomb)/sizeof(egesz_tomb[0]);
    /* mig i kissebb mint a hossz */
    while (i++ < hossz) {
        printf("%d ", egesz_tomb[i]);
    }
    printf("\n\n");

    /*
     * Egy matrix elemeinek kiiratasa ket egymasba agyazott for ciklussal
     */
    printf("Karakter tipusu tomb:\n"
           "---------------------\n");

    for (i=0; karakter_matrix[i][j]; ++i) {
        for (j=0; karakter_matrix[i][j]; ++j)
            printf("%c ", karakter_matrix[i][j]);
        printf("\n");
    }

    printf("Szam tipusu tomb:\n"
           "-----------------\n");

    for (i=0; i<3; ++i) {
        for (j=0; j<4; ++j)
            printf("%d ", egesz_matrix[i][j]);
        printf("\n");
    }

    getch();
}