/*
 * Description : Kobszamok
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.22
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

enum {
    MINSZAM = 1000,
    MAXSZAM = 9999,
    MAXSZAMHOSSZ = 4
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]) {
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void main (void) {
    int elso,masodik,i,aktkob=0,vege=0,joszam=0;
    char tmp[MAXSZAMHOSSZ+2];

    clrscr ();

    printf("Kobszamito program:\n"
           "==============================\n"
           "Kerem adja meg az elso szamot:\n"
           "------------------------------\n");
    do {
        if (!getline(tmp, MAXSZAMHOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXSZAMHOSSZ)
            printf("Tul sok karaktert adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            elso=atoi(tmp);
            if (elso < MINSZAM)
                printf("Nem adhat meg %d-nel kisebb szamot!\n", MINSZAM);
            else if (elso > MAXSZAM)
                printf("Nem adhat meg %d-nel nagyobb szamot!\n", MAXSZAM);
            else
                vege=1;
        }
    } while (!vege);

    vege=0;
    printf("Kerem adja meg a masodik szamot:\n"
           "--------------------------------\n");
    do {
        if (!getline(tmp, MAXSZAMHOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXSZAMHOSSZ)
            printf("Tul sok karaktert adott meg!\n");
        else if(!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            masodik=atoi(tmp);
            if(masodik < MINSZAM)
                printf("Nem adhat meg %d-nel kisebb szamot!\n", MINSZAM);
            else if (elso > MAXSZAM)
                printf("Nem adhat meg %d-nel nagyobb szamot!\n", MAXSZAM);
            else if (masodik < elso)
                printf("Masodik szam legyen nagyobb mint az elso.\n");
            else
                vege=1;
        }
    } while (!vege);

    printf("\n  Az elso szam: %d\n"
             "A masodik szam: %d\n\n", elso, masodik);

    for (i=11; i<22; ++i) {
        aktkob=i*i*i;
        if(aktkob>elso && aktkob<masodik) {
            printf("%d*%d*%d=%d       ", i, i, i, aktkob);
            ++joszam;
        }
    }

    if (joszam > 0)
        printf("\n\nOsszesen %d megfelelo szamot talatam.\n", joszam);
    else
        printf("\n\nNem talaltam megfelelo szamot.\n");

    getch();
}