/*
 * Description : Pros-paratlan
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.24
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <conio.h>

enum {
    MINSZAM=1,
    MAXSZAM=99
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int parosszamlalo(int szamok[], int szamdb){
    int parosdb=0, i;

    for (i=0; i<szamdb; ++i)
        if (!szamok[i]%2)
            ++parosdb;

    return parosdb;
}

int paratlanszamlalo(int szamok[], int szamdb){
    int paratlandb=0, i;

    for (i=0; i<szamdb; ++i)
        if (szamok[i]%2)
            ++paratlandb;

    return paratlandb;
}

int paratlanosszeg(int szamok[], int szamdb){
    int osszeg=0, i;

    for (i=0; i<szamdb; ++i)
        if (szamok[i]%2)
            osszeg+=szamok[i];

    return osszeg;
}

void main(void) {
    int i, paros=0, paratlan=0, aktszam, szamdb, ok=0, szamok[MAXSZAM], parost[MAXSZAM], paratlant[MAXSZAM];
    char tmp[7+1], c;

    clrscr();

    printf("Kerem adja meg, hogy hany szamot kerjunk be (min. %d - max. %d):\n"
           "----------------------------------------------------------------\n", MINSZAM, MAXSZAM);
    /* a darabszam bekerese */
    do {
        if (!getline(tmp, 3))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > 2)
            printf("Tul hosszu karaktersorozatot adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            szamdb=atoi(tmp);

            if (szamdb > MAXSZAM)
                printf("Maximum %d szamot adhat meg!\n", MAXSZAM);
            else if (szamdb < MINSZAM)
                printf("Minimum %d szamot kell megadnia!\n", MINSZAM);
            else
                ok=1;
        }
    } while (!ok);

    /* n darab szam bekerese */
    do {
        printf("Kerem adja meg a(z) %2d. szamot(min. -9999 max. 9999): ", paros+paratlan+1);
        if(!getline(tmp, 6))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > 4 && tmp[0]!='-' && tmp[0]!='+')
            printf("Tul hosszu karaktersorozatot adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            aktszam=atoi(tmp);
            if(aktszam > 9999)
                printf("Maximum 9999 -et adhat meg!\n");
            else if(aktszam<-9999)
                printf("Minimum -9999 -ot kell megadnia!\n");
            else {
                if (aktszam%2) {
                    paratlant[paratlan]=aktszam;
                    ++paratlan;
                } else {
                    parost[paros]=aktszam;
                    ++paros;
                }
                szamok[paros+paratlan]=aktszam;
            }
        }
    } while (paros+paratlan < szamdb);

    /* a szamok kiiratasa */
    printf("\n\nEzeket a szamokat olvastuk be :\n"
           "===============================\n"
           "     Paratlan   ||   Paros     \n");
    for (i=0; i<szamdb; ++i) {
        if(i<paratlan && i<paros)
            printf("     %5d      || %5d\n", paratlant[i], parost[i]);
        else if(i<paratlan && (i>=paros || paros==0))
            printf("     %5d      ||\n", paratlant[i]);
        else if(i<paros && (i>=paratlan || paratlan==0))
            printf("                || %5d\n", parost[i]);
        else
            break;
    }

    /* a paratlan adatok osszegenek kiiratasa */
    printf("\n\nParatlan szamok osszege: %d\n", paratlanosszeg(paratlant, paratlan));

    printf("\nA paros (p) vagy a paratlan (a) szamokat akarja kiiratni?\n");
    do {
        c=getch();
        if (c=='p') {
            printf("A paros szamok:\n"
                   "---------------\n");
            for(i=0; i<paros; ++i)
                printf("%d  ", parost[i]);
        } else if(c=='a') {
            printf("A paratlan szamok:\n"
                   "------------------\n");
            for(i=0; i<paratlan; ++i)
                printf("%d  ", paratlant[i]);
        } else {
            printf("Nem jo karaktert utott be!\n");
            fflush(stdin);
        }
    } while (c!='p' && c!='a');

    printf("\n");
    getch();
}