/*
 * Description : Uzemanyagos
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

enum {
    MINKM=1,
    MAXKM=2000,
    MINTANKOLAS=1,
    MAXTANKOLAS=100,
    MAXHOSSZ=4,
    BENZINAR=289
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int lebeg(char s[]){
    int i=0, kezd;
    while(isspace(s[i])) ++i;
    if(s[i]=='+'||s[i]=='-') ++i;
    kezd=i;
    while(isdigit(s[i])) ++i;
    if(s[i]=='.') ++i;
    while(isdigit(s[i])) ++i;
    if(i==kezd||kezd+1==i&&s[kezd]=='.') return 0;
    if(toupper(s[i])=='E'){
        ++i;
        if(s[i]=='+'||s[i]=='-')++i;
        if(!isdigit(s[i])) return 0;
        while(isdigit(s[i])) ++i;}
    if(isspace(s[i])||!s[i]) return 1;
    else return 0;
}

void main(void){
    char tmp[MAXHOSSZ+2];
    int ok=0, tavolsag, uzemanyag;

    clrscr();

    printf("Kerem adja meg a megtett km szamat (min. %d max. %d)\n", MINKM, MAXKM);
    do  {
        if(!getline(tmp, MAXHOSSZ+1))
            printf("Nem lehet ures sort megadni.\n");
        else if (strlen(tmp)>MAXHOSSZ)
            printf("Maximum %d karaktert adjon meg!\n", MAXHOSSZ);
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            tavolsag = atoi(tmp);

            if (tavolsag < MINKM)
                printf("Minimum %d kilometert adjon meg.\n", MINKM);
            else if (tavolsag > MAXKM)
                printf("Minimum %d kilometert adjon meg.\n", MINKM);
            else
                ok=1;
        }
    } while(!ok);

    printf("Kerem adja meg a tankolt benzin mennyiseget (min. %d max. %d)\n", MINTANKOLAS, MAXTANKOLAS);
    ok=0;
    do  {
        if(!getline(tmp, MAXHOSSZ+1))
            printf("Nem lehet ures sort megadni.\n");
        else if (strlen(tmp)>MAXHOSSZ)
            printf("Maximum %d karaktert adjon meg!\n", MAXHOSSZ);
        else if (!lebeg(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            uzemanyag = atof(tmp);

            if (uzemanyag < MINTANKOLAS)
                printf("Minimum %d kilometert adjon meg.\n", MINTANKOLAS);
            else if (uzemanyag > MAXTANKOLAS)
                printf("Minimum %d kilometert adjon meg.\n", MAXTANKOLAS);
            else
                ok=1;
        }
    } while(!ok);

    printf("Atlagfogyasztas: %.2fl/100km, 100Km %.2fFt-ba kerult.\n", (double)uzemanyag/tavolsag*100, ((double)uzemanyag/tavolsag*100)*BENZINAR);

    getch();
}