/*
 * Description : Homersekleteks
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>

enum {
    MAXHOSSZ=6,
    MAXORA=5,
    MIN=-100,
    MAX=100,
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int lebege(char s[]){
    int i=0, kezd;
    while(isspace(s[i])) ++i;
    if(s[i]=='+'||s[i]=='-') ++i;
    kezd=i;
    while(isdigit(s[i])) ++i;
    if(s[i]=='.') ++i;
    while(isdigit(s[i])) ++i;
    if(i==kezd||kezd+1==i&&s[kezd]=='.') return 0;
    if(toupper(s[i])=='E'){
    ++i;
    if(s[i]=='+'||s[i]=='-')++i;
    if(!isdigit(s[i])) return 0;
    while(isdigit(s[i])) ++i;}
    if(isspace(s[i])||!s[i]) return 1;
    else return 0;
}

void main(void) {
    int i, jo=0, rossz=0, minIndex=0, maxIndex=0;
    float homersekletek[MAXORA], min, max, atlag=0, hom;
    char tmp[MAXHOSSZ + 2];

    clrscr();

    printf("Kerem adja meg a homersekleti adatokat (min. %d max. %d es max. %d adatot adhat meg!\n", MIN, MAX, MAXORA);

    do {
        if (!getline(tmp, MAXHOSSZ + 1)) {
            printf("Ures sor, a homerseklet -273.3 lesz!\n");
            homersekletek[jo + rossz] = -273.3;
            ++rossz;
        } else if (strlen(tmp) > MAXHOSSZ)
            printf("Tul hosszu karaktersorozatot adott meg!\n");
        else if(!lebege(tmp))
            printf("Nem lebegopontos szamot adott meg!\n");
        else {
            hom = atof(tmp);
            if (hom < MIN)
                printf("A legkisebb homerseklet %d lehet!\n", MIN);
            else if (hom > MAX)
                printf("A legnagyobb homerseklet maximum %d lehet!\n", MAX);
            else {
                homersekletek[jo + rossz] = hom;
                ++jo;
            }
        }
    } while (jo+rossz<MAXORA);

    printf("----------------------------------------------------\n"
           "%d homersekletet adtak meg es %d az alapertelmezett!\n"
           "----------------------------------------------------\n", jo, rossz);

    if(jo != 0) {
        min = homersekletek[0];
        max = homersekletek[0];

        for (i=0; i<jo+rossz; ++i) {
            if (homersekletek[i] < min) {
                min = homersekletek[i];
                minIndex = i;
            }

            if (homersekletek[i] > max) {
                max = homersekletek[i];
                maxIndex = i;
            }

            if (homersekletek[i] > MIN)
                atlag += homersekletek[i];
        }

        printf("A tombben levo homersekletek felsorolva:\n"
               "----------------------------------------\n");

        for(i=0; i<jo+rossz; ++i)
            printf("%d. orakor a homerseklet: %.2f\n", i, (float)homersekletek[i]);

        printf("A leghidegebb %d orakor volt mely %.2f c'.\n", minIndex, (float)min);
        printf("A legmelegebb %d orakor volt mely %.2f c'.\n", maxIndex, (float)max);
        printf("Az atlaghomerseklet %.2f C' volt %d adat alapjan.\n", (float)atlag/jo, jo);
    } else {
        printf("Nem adtak meg egy adatot sem, igy nem lehet szamitasokat vegezni! A tomb tartalma:\n");
        for(i=0; i<rossz; ++i)
            printf("%d. orakor a homerseklet: %.2f\n", i, (float)homersekletek[i]);
    }
    for (i=0; i<jo+rossz; ++i)
        if (i%2)
            printf("%d. elem cime: %p\n", i, &homersekletek[i]);

    getch();
}