/*
 * Description : Kaloriaszamlalo
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>

enum {
    MAXHOSSZ=20,
    TOMEGMIN=0,
    TOMEGMAX=2,
    KALORIAMIN=0,
    KALORIAMAX=2000
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]) {
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int lebeg(char s[]) {
    int i=0, kezd;
    while(isspace(s[i])) ++i;
    if(s[i]=='+'||s[i]=='-') ++i;
    kezd=i;
    while(isdigit(s[i])) ++i;
    if(s[i]=='.') ++i;
    while(isdigit(s[i])) ++i;
    if(i==kezd||kezd+1==i&&s[kezd]=='.') return 0;
    if(toupper(s[i])=='E'){
    ++i;
    if(s[i]=='+'||s[i]=='-')++i;
    if(!isdigit(s[i])) return 0;
    while(isdigit(s[i])) ++i;}
    if(isspace(s[i])||!s[i]) return 1;
    else return 0;
}

int main(void) {
    char tmp[MAXHOSSZ + 2], nev[MAXHOSSZ + 2];
    int kaloria, i, ok=0;
    double mennyiseg, kaloriatartalom;

    clrscr();

    printf("Kaloriaszamlalo program\n"
           "-----------------------\n"
           "Kerem adja meg a sutemeny nevet:\n");
    do {
        if (!getline(nev, MAXHOSSZ+1)) {
            printf("Ures sor, a program kilep!\n");
            getch();
            exit(0);
        } else if (strlen(nev) > MAXHOSSZ)
            printf("A sutemeny neve maximum %d hosszu lehet!\n", MAXHOSSZ);
        else
            ok = 1;
    } while (!ok);

    ok = 0;
    printf("Kerem adja meg a sutemeny mennyiseget:\n");
    do {
        if (!getline(tmp, MAXHOSSZ+1)) {
            printf("Ures sor, a program kilep!\n");
            getch();
            exit(0);
        } else if (strlen(tmp) > MAXHOSSZ)
            printf("A tul hosszu karaktersorozatot adott meg!\n");
        else if (!lebeg(tmp))
            printf("Nem lebegopontos szamot adott meg!\n");
        else {
            mennyiseg = atof(tmp);
            if (mennyiseg < TOMEGMIN)
                printf("A mennyiseg minimum %d legyen!\n", TOMEGMIN);
            else if (mennyiseg > TOMEGMAX)
                printf("A mennyiseg maximum %d legyen!\n", TOMEGMAX);
            else
                ok = 1;
        }
    } while (!ok);

    ok = 0;
    printf("Kerem adja meg a sutemeny kaloriatartalmat:\n");
    do {
        if (!getline(tmp, MAXHOSSZ+1)) {
            printf("Ures sor, a program kilep!\n");
            getch();
            exit(0);
        } else if (strlen(tmp) > MAXHOSSZ)
            printf("A tul hosszu karaktersorozatot adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            kaloria = atoi(tmp);
            if (kaloria < KALORIAMIN)
                printf("A kaloria minimum %d legyen!\n", KALORIAMIN);
            else if (kaloria > KALORIAMAX)
                printf("A kaloria maximum %d legyen!\n", KALORIAMAX);
            else
                ok = 1;
        }
    } while (!ok);

    printf("A sutemeny neve           : %s\n"
           "A sutemeny mennyisege     : %.2f kg\n"
           "Kaloria 100g-ban          : %d kca\n"
           "A sutemeny kaloriatartalma: %.2f kca\n", nev, mennyiseg, kaloria, ((mennyiseg*1000)/100)*kaloria);

    getch();
}