/*------------------------------------------
//          Telefonos szavazas
//              by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#define MAXHOSSZ 9

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int szamellenorzo(char szam[]) {
    int i;
    if (strlen(szam)!=MAXHOSSZ) {
        printf("A megadott szam nem %d hosszu!\n", MAXHOSSZ);
        return 0;
    }
    if(szam[0]!='2' && szam[0]!='3' && szam[0]!='7' || szam[1]!='0'){
        printf("A megadott szam nem 20-30 vagy 70-es korzetszammal kezdodik!\n");
        return 0;
    }
    for (i=2; i<MAXHOSSZ; ++i) {
        if (!isdigit(szam[i])) {
            printf("A megadott telefonszam nem csak egesz szamokat tartalmaz!\n");
            return 0;
        }
    }
    return 1;
}

int joszavazat(char szavazat[]) {
    if (strlen(szavazat)!=1) {
        printf("A szavazatnak egy karaterbol kell allnia!\n");
        return 0;
    }
    szavazat[0] = tolower(szavazat[0]);
    if (szavazat[0]!='a' && szavazat[0]!='b' && szavazat[0]!='c' && szavazat[0]!='d') {
        printf("Nem megfelelo szavazatot adott meg!\n");
        return 0;
    }
    return 1;
}

void main(void) {
    char tmp[MAXHOSSZ+2], tiltott[MAXHOSSZ+2];
    int i, ok=0, huszas=0, harmincas=0, hetvenes=0, szavazatok[4], ervenytelen=0, maxszavazat, maxszavazatindex;

    clrscr();
    printf("Kerem adja meg a tiltott telefonszamot: ");

    for (i=0; i<4; ++i)
        szavazatok[i]=0;

    do {
        getline(tiltott, MAXHOSSZ+1);
    } while (!szamellenorzo(tiltott));

    do {
        printf("Kerem adja meg a telefonszamot: ");
        do {
            if (!getline(tmp, MAXHOSSZ+1)){
                maxszavazat = szavazatok[0];
                maxszavazatindex = 0;

                for (i=0; i<szavazatok[4]; ++i) {
                    if (szavazatok[i] > maxszavazat) {
                        maxszavazat = szavazatok[i];
                        maxszavazatindex = i;
                    }
                }

                printf("Szavazatok:\n"
                       "-----------\n"
                       "A : %d\n"
                       "B : %d\n"
                       "C : %d\n"
                       "D : %d\n\n", szavazatok[0], szavazatok[1], szavazatok[2], szavazatok[3]);

                printf("Szamok:\n"
                       "-------\n"
                       "20: %d\n"
                       "30: %d\n"
                       "70: %d\n\n", huszas, harmincas, hetvenes);

                printf("A legtobb szavazat a(z) %c szavazatbol jott.\n"
                       "Az ervenytelen szavazatok szama %d db.\n", maxszavazatindex+'A', ervenytelen);
                getch();
                exit(0);
            }
        } while (!szamellenorzo(tmp));

        if (tmp[0]=='2')
            ++huszas;
        else if (tmp[0]=='3')
            ++harmincas;
        else if (tmp[0]=='7')
            ++hetvenes;

        if (!strcmp(tmp, tiltott)) {
            printf("On nem adhat le szavazatot!\n");
        } else {
            ok=0;
            printf("Kerem adja meg a szavazatot: ");
            do {
                getline(tmp, 2);
                if (!joszavazat(tmp)) {
                    ++ervenytelen;
                } else {
                    ok=1;
                    if (tmp[0]=='a')
                        ++szavazatok[0];
                    else if (tmp[0]=='b')
                        ++szavazatok[1];
                    else if (tmp[0]=='c')
                        ++szavazatok[2];
                    else
                        ++szavazatok[3];
                }
            } while (!ok);
        }
    } while (1);
}