/*
 * Description : Szamforditas
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

enum {
    SZAMHOSSZ=4,
    SZERENCSESZAM=2000
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}


int egesz(char s[]) {
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void main(void) {
    char szamt1[SZAMHOSSZ+2], szamt2[SZAMHOSSZ+2];
    int szam1, szam2, beolvasott=0, osszeg=0, vege=0;

    clrscr();

    do {
        printf("Kerem adjon meg egy %d jegyu szamot:\n", SZAMHOSSZ);

        if (!getline(szamt1, SZAMHOSSZ+1)) {
            printf("Ures sort utott, vege a bekeresnek.\n");
            vege=1;
        } else if (strlen(szamt1) != SZAMHOSSZ)
            printf("A szam %d karakterbol alljon!\n", SZAMHOSSZ);
        else if (!egesz(szamt1))
            printf("Nem egesz szamot adot tmeg!\n");
        else {
            strcpy(szamt2, szamt1);
            strrev(szamt2);

            szam1 = atoi(szamt1);
            szam2 = atoi(szamt2);

            if (!strcmp(szamt1, szamt2))
                printf("A ket szam megegyezik.\n\n");
            else if (szam1 > szam2)
                printf("Az eredeti szam a nagyobb.\n\n");
            else
                printf("A kepzett szam a nagyobb.\n\n");

            printf("Eredeti szam    : %d\n"
                   "Keletkezett szam: %d\n"
                   "Osszeguk        : %d\n"
                   "Kulombseguk     : %d\n"
                   "Atlaguk         : %.2f\n\n", szam1, szam2, szam1+szam2, szam1-szam2, (szam1+szam2)/2);

            if (szam1 == SZERENCSESZAM || szam2 == SZERENCSESZAM)
                printf("Ez egy szerencses szam!\n");

            osszeg += szam1;
            ++beolvasott;
        }
    } while(!vege);

    if (!beolvasott)
        printf("Egy szamot sem adtak meg.\n");
    else
        printf("A beolvasott %d darab szam atlaga %.2f.\n", beolvasott, osszeg/(double)beolvasott);

    getch();
}