/*------------------------------------------
//              Kockadobas
//              by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#define MAXDOBAS 100

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int jodobas(char dobasok[]){
    int i;
    for(i=0; dobasok[i]!='\0'; ++i) {
        if (!isdigit(dobasok[i]))
            return 0;
        if (dobasok[i]-'0'<0 || dobasok[i]-'0'>6)
            return 0;
    }
    return 1;
}

void main(void) {
    char tmp[MAXDOBAS+2];
    int dobasok, i, j, szamok[7], ok=0, maxdobas, maxszam;

    clrscr();

    printf("Hany kockadobast vegez? ");

    for (i=1; i<=6; ++i)
        szamok[i]=0;

    do {
        if (!getline(tmp, MAXDOBAS+1))
            printf("Nem adhat meg ures sort!\n");
        else if (strlen(tmp)>3)
            printf("Tul sok karaktert adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            dobasok = atoi(tmp);

            if (dobasok==0) {
                printf("0-t adott meg, a program kilep!");
                getch();
                exit(0);
            }

            if (dobasok < 0)
                printf("A dobasok szama nem lehet negativ.");
            else if (dobasok > MAXDOBAS)
                printf("A dobasok szama maximum %d lehet.", MAXDOBAS);
            else
                ok = 1;
        }
    } while (!ok);

    ok=0;
    printf("Irja be a kockadobasok eredmenyeit: ");
    do {
        if (!getline(tmp, MAXDOBAS+1)) {
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if (strlen(tmp)!=dobasok)
            printf("%d db dobast kell megadnia!\n", dobasok);
        else if (!jodobas(tmp))
            printf("Nem megfelelo dobassorozatot adott meg!\n");
        else {
            ok=1;
            for (i=0; i<dobasok; ++i)
                ++szamok[tmp[i]-'0'];
        }
    } while (!ok);

    printf("Eredmenyek:\n"
           "-----------\n");
    maxszam  = 1;
    maxdobas = szamok[1];
    for (i=1; i<=6; ++i) {
        printf("%d: %d db\n", i, szamok[i]);
        if (maxdobas < szamok[i]) {
            maxdobas = szamok[i];
            maxszam  = i;
        }
    }

    printf("Savdiagram:\n"
           "-----------\n");
    for (i=1; i<=6; ++i) {
        if (szamok[i] > 0) {
            printf("%d: ", i);
            for (j=0; j<szamok[i]; ++j) {
                printf("*");
            }
            printf("\n");
        }
    }

    printf("A legtobb dobas a(z) %d. szambol volt, ami az osszes dobas %.2f szazaleka volt.", maxszam, maxdobas*100/(double)dobasok);
    getch();
}