/*
 * Description : Pulzusszam
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>

enum {
    HOSSZ=3,
    MAXDBSZAM=12,
    MINPULZUS=140,
    MAXPULZUS=198,
    PULZUSLOWMIN=140,
    PULZUSLOWMAX=170,
    PULZUSMEDIUMMIN=171,
    PULZUSMEDIUMMAX=185,
    PULZUSHIGHMIN=186,
    PULZUSHIGHMAX=198
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void main(void) {
    double atlag=0;
    char tmp[HOSSZ+2];
    int bekert=0, pulzusok[MAXDBSZAM], pulzus, i, ok=0, minpulzus, maxpulzus, minhely, maxhely, alacsony=0, kozepes=0, magas=0;

    clrscr();

    printf("Kerem adja meg a pulzusszamokat, min %d - max %d, maximum %d darabot\n"
           "=====================================================================\n", MINPULZUS, MAXPULZUS, MAXDBSZAM);

    do {
        printf("Kerem adja meg a(z) %d. pulzust: ", bekert+1);
        if (!getline(tmp, HOSSZ+1))
            ok=1;
        else if (strlen(tmp) != HOSSZ)
            printf("A szamnak %d hosszunak kell lennie!\n", HOSSZ);
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            pulzus = atoi(tmp);

            if (pulzus < MINPULZUS)
                printf("A pulzus minimum %d legyen!\n", MINPULZUS);
            else if (pulzus > MAXPULZUS)
                printf("A pulzus maximum %d legyen!\n", MAXPULZUS);
            else {
                if (pulzus >= PULZUSLOWMIN && pulzus <= PULZUSLOWMAX)
                    ++alacsony;
                else if (pulzus >= PULZUSMEDIUMMIN && pulzus <= PULZUSMEDIUMMAX)
                    ++kozepes;
                else
                    ++magas;

                pulzusok[bekert] = pulzus;
                ++bekert;
            }
        }
    } while (!ok && bekert!=MAXDBSZAM);

    printf("Az adatbekeresnek vege!\n"
           "-----------------------\n");

    if (bekert!=0) {
        minpulzus = maxpulzus = pulzusok[0];
        minhely = maxhely = 1;

        for (i=0; i<bekert; ++i) {
            if (pulzusok[i] < minpulzus) {
                minpulzus = pulzusok[i];
                minhely = i+1;
            }

            if (pulzusok[i] > maxpulzus) {
                maxpulzus = pulzusok[i];
                maxhely = i+1;
            }
            atlag += pulzusok[i];
        }

        atlag /= bekert;

        printf("A minimum %d volt a %d. helyen\n", minpulzus, minhely);
        printf("A maximum %d volt ", maxpulzus);

        if (minhely < maxhely)
            printf("%d masodperccel a minimum utan.\n", (maxhely-minhely)*5);
        else
            printf("%d masodperccel a minimum elott.\n", (minhely-maxhely)*5);

        printf("Az pulzus atlaga %.2f volt amely %.2f-el nagyobb mint a minimum es %.2f-el kisebb mint a maximum.\n", atlag, atlag-minpulzus, (atlag-maxpulzus)*(-1));

        if (maxpulzus == MAXPULZUS)
            printf("A terheles elerte a maximalis erteket.\n");
        else
            printf("A terheles nem erte el a maximalis erteket, %d utessel maradt el a maximumtol.\n", MAXPULZUS-maxpulzus);

        printf("140 - 170 -> %.2d masodperc\n"
               "171 - 185 -> %.2d masodperc\n"
               "186 - 198 -> %.2d masodperc\n", alacsony*5, kozepes*5, magas*5);
    } else {
        printf("Nem adtak meg egyetlen pulzust sem!\n");
    }

    getch();
}