/*
 * Description : Szineszek
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.28
 */
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>

enum {
    MINELETKOR=0,
    MAXELETKOR=100,
    MAXELETKORKAR=3,
    MAXNEVHOSSZ=100,
    MAXSZINESZDB=100
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int jonev(char nev[]) {
    int i, alahuzas=0, kotojel=0;

    for (i=0; nev[i]; ++i) {
        if (!islower(nev[i]) && nev[i]!='_' && nev[i]!='-')
            return 0;

        if (nev[i]=='_')
            ++alahuzas;
            
        if (nev[i]=='_-)
            ++kotojel;
    }

    if(alahuzas==1  && kotojel==1)
        return 1;

    return 0;
}

void alakit(char nev[]) {
    int i;

    /* a nev tomb elso betujet automatikusan konvertaljuk */
    nev[0] = toupper(nev[0]);

    for (i=0; nev[i]; ++i) {
        if (nev[i] == '_') {
            nev[i] = ' ';
            nev[i+1] = toupper(nev[i+1]);
        }
        if (nev[i] == '-') {
            nev[i+1] = toupper(nev[i+1]);
        }
    }
}

void angolnev(char nev[]) {
    int i;

    for(i=0; nev[i]!=' '; ++i);

    ++i;

    for (; nev[i]; ++i)
        printf("%c", nev[i]);

    printf(", ");

    for (i=0; nev[i]!=' '; ++i)
        printf("%c", nev[i]);
}

struct adatok {
    char nev[MAXNEVHOSSZ+1];
    int eletkor;
};

void main(void) {
    char tmp[MAXNEVHOSSZ+2];
    struct adatok szineszek[MAXSZINESZDB];
    int vege=0, ok, i=0, eletkor, legoregebb=0, index=0, eletkor_osszeg=0, bekert=0;

    clrscr();

    do {
        ok=0;
        printf("Kerem adja meg a(z) %d. szinesz nevet:\n", bekert+1);
        do {
            if(!getline(tmp, MAXNEVHOSSZ+1)) {
                printf("Ures sort utott, vege a bekeresnek.\n\n");
                vege=1;
                ok=1;
            } else if (strlen(tmp) > MAXNEVHOSSZ)
                printf("Maximum %d hosszu nevet adjon meg!\n");
            else if (!jonev(tmp))
                printf("A nev nem megfelelo formatumu!\n");
            else {
                alakit(tmp);
                strcpy(szineszek[bekert].nev, tmp);
                ok=1;
            }
        } while(!ok);

        if (!vege) {
            ok=0;
            printf("Kerem adja meg a(z) %d. szinesz korat:\n", bekert+1);
            do {
                if(!getline(tmp, MAXELETKORKAR+1)) {
                    printf("Nem adhat meg ures sort.\n");
                } else if (strlen(tmp) > MAXELETKORKAR)
                    printf("Az eletkor maximum %d karakterbol allhat!\n",MAXELETKORKAR);
                else {
                    eletkor = atoi(tmp);

                    if (eletkor < MINELETKOR)
                        printf("A legkisebb eletkor %d lehet!\n", MINELETKOR);
                    else if (eletkor > MAXELETKOR)
                        printf("A legnagyobb eletkor %d lehet!\n", MAXELETKOR);
                    else {
                        if (szineszek[bekert].eletkor > legoregebb) {
                            legoregebb = szineszek[bekert].eletkor;
                            index = bekert;
                        }

                        szineszek[bekert].eletkor = eletkor;
                        eletkor_osszeg+=szineszek[bekert].eletkor;
                        ++bekert;
                        ok=1;
                    }
                }
            } while(!ok);
        }
    } while(!vege);

    if (bekert!=0) {
        for(i=0; i<bekert; ++i) {
            /* a nev atalakitasa, hiaba nincs visszateresi ertek, a tombok cim
             * szerinti parameteratadasa miatt a parameterkent megadott tombunk
             * tartalmat modositjuk */        
            angolnev(szineszek[i].nev);
            printf(" %d eves.\n", szineszek[i].eletkor);
        }

        printf("A szineszek atlageletkora %.2f\n"
               "%s a legoregebb %d evvel.\n", (double)eletkor_osszeg/bekert, szineszek[index].nev, szineszek[index].eletkor);
    } else {
        printf("Egy szinesz adatait sem adtak meg.\n");
    }
    getch();
}