/*------------------------------------------
//                Szineszek
//                by -zolee-
//
//
//  A feladat leirasat lasd a !Feladat!.jpg
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

enum {NEVMIN=5, NEVMAX=30, KORMIN=0, KORMAX=100};

int egesz(char s[]) {
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]) {
        if(!isdigit(s[i]))return 0;
            ++i;
    }
    return 1;
}

int getline(char s[],int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void atalakit(char nev[]) {
    unsigned int i;

    // a nev tomb elso betujet automatikusan konvertaljuk
    nev[0] = toupper(nev[0]);
    // vegigmegyunk a neven az autolso elotti elemig, mivel utolso elem eseteben
    // az i+1 tombon kivuli cimre hivatkozna
    for (i=0; i<strlen(nev)-1; ++i) {
        if (nev[i] == '_') {
            nev[i] = ' ';
            nev[i+1] = toupper(nev[i+1]);
        }
        if (nev[i] == '-') {
            nev[i+1] = toupper(nev[i+1]);
        }
    }
}

int jonev(char nev[]) {
	unsigned int i;

    for (i=0; i<strlen(nev); ++i) {
        if (!islower(nev[i]) && nev[i]!='_' && nev[i] != '-') {
            return 0;
        }
    }
    return 1;
}

void main(void) {
    char tmp[NEVMAX+2], legidosebb[NEVMAX+1], nev[NEVMAX+2];
    int ok, vege=0, db=0, max_eletkor = -1, tmp_eletkor;
    float eletkor_osszeg = 0;

    clrscr();

    do {
        printf("Kerem adja meg a szinesz nevet:\n");
        ok = 0;
        do {
            if (!getline(tmp, NEVMAX+1)) {
                if (db > 0) {
                    vege = 1;
                    ok = 1;
                } else {
                    printf("Legalabb egy szineszt meg kell adnia!\n");
                }
            } else if (strlen(tmp) > NEVMAX) {
                printf("A nev maximum %d karakterbol allhat!\n", NEVMAX);
            } else if (strlen(tmp) < NEVMIN) {
                printf("A nev minimum %d karakterbol alljon!\n", NEVMIN);
            } else if (!jonev(tmp)){
                printf("A nev nem megfelelo formatumu!\n");
            } else {
                strcpy(nev, tmp);
                ok = 1;
            }
        } while (!ok);

        if (!vege) {
            printf("Kerem adja meg %s eletkorat:\n", nev);
            ok = 0;
            do {
                if (!getline(tmp, 4)) {
                    printf("Nem adhat meg ures sort!\n");
                } else if (strlen(tmp) > 3) {
                    printf("Tul hosszu karaktersort adott meg!\n");
                } else if (!egesz(tmp)) {
                    printf("Nem egesz szamot adott meg!\n");
                } else {
                    tmp_eletkor = atoi(tmp);
                    if (tmp_eletkor > KORMAX) {
                        printf("%s maximum %d eves lehet!\n", nev, KORMAX);
                    } else if (tmp_eletkor < KORMIN) {
                        printf("%s minimum %d eves legyen!\n", nev, KORMIN);
                    } else {
                        eletkor_osszeg += tmp_eletkor;
                        if (tmp_eletkor > max_eletkor) {
                            max_eletkor = tmp_eletkor;
                            strcpy(legidosebb, nev);
                        }
                        ok = 1;
                    }
                }
            } while (!ok);

            // az aeredti nev kiiratasa konvertalas elott
            printf("------------------------------\n"
                   "%s\n", nev);
            // a nev atalakitasa, hiaba nincs visszateresi ertek, a tombok cim
            // szerinti parameteratadasa miatt a parameterkent megadott tombunk
            // tartalmat modositjuk
            atalakit(nev);
            // a nevhez tartozo eletkor es a modositott nev megjelenitese
            printf("%d\n"
                   "%s\n"
                   "------------------------------\n", tmp_eletkor, nev);
            ++db;
        }
    } while (!vege);

    printf("A legidosebb szinesz %s %d eves.\n"
           "Az atlageletkor %.2f ev.\n", legidosebb, max_eletkor, eletkor_osszeg/db);
}