/*
 * Description : Szamsor bekero
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.28
 */
#include <math.h>
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

enum{
    HOSSZ=5,
    SZAMMIN=10,
    SZAMMAX=20,
    MINSZAMDB=2,
    MAXSZAMDB=100
};

int lebeg(char s[]) {
    int i=0, kezd;
    while(isspace(s[i])) ++i;
    if(s[i]=='+'||s[i]=='-') ++i;
    kezd=i;
    while(isdigit(s[i])) ++i;
    if(s[i]=='.') ++i;
    while(isdigit(s[i])) ++i;
    if(i==kezd||kezd+1==i&&s[kezd]=='.') return 0;
    if(toupper(s[i])=='E'){
    ++i;
    if(s[i]=='+'||s[i]=='-')++i;
    if(!isdigit(s[i])) return 0;
    while(isdigit(s[i])) ++i;}
    if(isspace(s[i])||!s[i]) return 1;
    else return 0;
}

int egesz(char s[]) {
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]) {
        if(!isdigit(s[i]))return 0;
            ++i;
    }
    return 1;
}

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void rendezesNovekvobe(float szamok[], int szamdb) {
    float temp;
    int i, j;

    for (i=0; i<szamdb; ++i) {
        for(j=0; j<szamdb-1; ++j) {
            if (szamok[j] > szamok[j+1]) {
                temp = szamok[j];
                szamok[j] = szamok[j+1];
                szamok[j+1] = temp;
            }
        }
    }
}

int intervall(float szam) {
    if (szam <= SZAMMIN) {
        printf("%d szamnal nagyobbat adjon meg!\n", SZAMMIN);
        return 0;
    }

    if (szam >= SZAMMAX) {
        printf("%d szamnal kissebbet adjon meg!\n", SZAMMAX);
        return 0;
    }

    return 1;
}

void main(void) {
    float szamdb, szamok[MAXSZAMDB], osszeg=0, negyzetosszeg=0;
    int i, bekert=0, ok=0;
    char tmp[HOSSZ+2];

    clrscr();

    printf("Kerem adja meg hany szamot kerjunk be (min %d max %d)\n", SZAMMIN, SZAMMAX);

    do {
        if (!getline(tmp, HOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            szamdb = atoi(tmp);

            if (szamdb < MINSZAMDB)
                printf("Minimum %d szamot kell bekerni!\n", MINSZAMDB);
            else if (szamdb > MAXSZAMDB)
                printf("Maximum %d szamot lehet bekerni!\n", MAXSZAMDB);
            else
                ok = 1;
        }
    } while(!ok);

    do {
        printf("Kerem adja meg a(z) %2d. szamot: ", bekert+1);

        if (!getline(tmp, HOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) != HOSSZ)
            printf("A megadott szam %d karakterbol alljon!\n", HOSSZ);
        else if (!lebeg(tmp))
            printf("Nem lebegopontos szamot adott meg!\n");
        else {
            szamok[bekert] = atof(tmp);
            /* intervallum ellenorzes */
            if (intervall(szamok[bekert]))
                ++bekert;
        }
    } while(bekert < szamdb);

    printf("A megadott novekvo sorrendbe rendezett szamok:\n");
    /* buborek rendezes*/
    rendezesNovekvobe(szamok, bekert);

    for (i=0; i<bekert; ++i) {
        printf("%.2f ", szamok[i]);
        negyzetosszeg += szamok[i] * szamok[i];
        osszeg += szamok[i];
    }

    printf("\nOsszeg             : %.2f\n"
             "Negyzetosszeg      : %.2f\n"
             "Negyzetosszeg gyoke: %.2f\n", osszeg, negyzetosszeg, sqrt(negyzetosszeg));

    getch();
}