/*
 * Description : Utasok
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.29
 */
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

enum {
    AKTEV=2011,
    MAXUTASDB=10,
    MAXNEVHOSSZ=100,
};

int egesz(char s[]) {
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]) {
        if(!isdigit(s[i]))return 0;
            ++i;
    }
    return 1;
}

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int evell(char ev[]) {
    int i, evszam;

    if (strlen(ev) != 4)
        return 0;

    for (i=0; ev[i]; ++i)
        if (!isdigit(ev[i]))
            return 0;

    evszam=atoi(ev);

    if (evszam>=AKTEV || evszam<1900)
        return 0;

    return 1;
}

int nevell(char nev[]) {
    int i;

    for (i=0; nev[i]; ++i)
        if (!isalpha(nev[i]) && nev[i]!=' ')
            return 0;

    return 1;
}

struct adatok {
    char nev[MAXNEVHOSSZ+1];
    int szuletesi_ev, utazas_hossz;
};

void main(void) {
    char tmp[MAXNEVHOSSZ+2], ok, vege=0, bekert=0;
    struct adatok utasok[MAXUTASDB];
    int ev_osszeg=0, i, j, mineletkor, maxtav, maxtavindex, mineletkorindex;

    clrscr();

    do {
        printf("Kerem adja meg a(z) %d. utas nevet:\n", bekert+1);
        ok=0;
        do {
            if (!getline(tmp, MAXNEVHOSSZ+1)) {
                printf("Ures sort utott, vege a bekeresnek.\n\n");
                vege=1;
                ok=1;
            } else if (strlen(tmp) > MAXNEVHOSSZ)
                printf("Maximum %d hosszu nevet adhat meg!\n", MAXNEVHOSSZ);
            else if (!nevell(tmp))
                printf("A nev nem megfelelo formatumu.\n");
            else {
                strcpy(utasok[bekert].nev, tmp);
                ok=1;
            }
        } while(!ok);

        if (!vege) {
            printf("Kerem adja meg a(z) %d. szuletesi evet:\n", bekert+1);
            ok=0;
            do {
                if (!getline(tmp, 5))
                    printf("Nem adhat meg ures sort!\n");
                else if (strlen(tmp) != 4)
                    printf("Az evszam 4 hosszu legyen!\n");
                else if (!evell(tmp))
                    printf("Nem jo formatumot adott meg!\n");
                else {
                    utasok[bekert].szuletesi_ev=atoi(tmp);
                    ev_osszeg+=AKTEV-utasok[bekert].szuletesi_ev;
                    ok=1;
                }
            } while(!ok);

            printf("Kerem adja meg a(z) %d. utas utazasi hosszat:\n", bekert+1);
            ok=0;
            do {
                if (!getline(tmp, 5))
                    printf("Nem adhat meg ures sort!\n");
                else if (!egesz(tmp))
                    printf("Nem egesz szamot adott meg!\n");
                else {
                    utasok[bekert].utazas_hossz=atoi(tmp);
                    ok=1;
                }
            } while(!ok);

            ++bekert;

            if (bekert == MAXUTASDB)
                printf("Bekertuk %d utas adatait, vege a bekeresnek.", bekert+1);
        }
    } while(!vege);

    if (bekert != 0) {
        printf("Az utasok atlageletkora %.2f ev.\n"
               "Az utasok neveinek kezdobetui: ", (double)ev_osszeg/bekert);

        mineletkor = utasok[0].szuletesi_ev;
        maxtav = utasok[0].utazas_hossz;
        mineletkorindex=0;
        maxtavindex=0;

        for (i=0; i<bekert; ++i)
            printf("%c", utasok[i].nev[0]);

        for (i=0; i<bekert; ++i) {
            for (j=0; j<bekert-1; ++j) {
                if (strcmp(utasok[j].nev, utasok[j+1].nev) > 0) {
                    strcpy(tmp, utasok[j].nev);
                    strcpy(utasok[j].nev, utasok[j+1].nev);
                    strcpy(utasok[j+1].nev, tmp);
                }
            }
        }

        for (i=0; i<bekert; ++i) {
            if (utasok[i].szuletesi_ev > mineletkor) {
                mineletkor = utasok[i].szuletesi_ev;
                mineletkorindex = i;
            }

            if (utasok[i].utazas_hossz > maxtav) {
                maxtav = utasok[i].utazas_hossz;
                maxtavindex = i;
            }
        }

        printf("\nA nevsorban az elso utas: %s\n"
                 "A legfiatalabb utas     : %s\n"
                 "A legtobbet utazo utas  : %s\n", utasok[0].nev, utasok[mineletkorindex].nev, utasok[maxtavindex].nev);

    } else {
        printf("Egy utas adatait sem adtak meg.\n");
    }
    getch();
}