/*
 * Description : Felelossegbizotsitas
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.29
 */
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#define letokw(a) a*0.735
#define kwtoft(a) a*400

enum {
    MAXDB=50,
    MINLE=1,
    MAXLE=300,
    MAXHOSSZ=3,
    KOZEPERTEK=20000,
};

int egesz(char s[]) {
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]) {
        if(!isdigit(s[i]))return 0;
            ++i;
    }
    return 1;
}

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void) {
    char tmp[MAXHOSSZ+2];
    int le, vege=0, keves=0, sok=0, bekert=0;
    double ar, kw, osszeg=0, min=100000, max=0;

    clrscr();

    do {
        printf("Kerem adja meg a(z) %d teljesitmenyt (min. %d max, %d):\n", bekert, MINLE, MAXLE);

        if (!getline(tmp, MAXHOSSZ+1)) {
            printf("Ures sort utott, vege a bekeresnek.\n\n");
            vege=1;
        } else if (strlen(tmp) > MAXHOSSZ)
            printf("Tul hosszu karaktersorozatot adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else  {
            le = atoi(tmp);

            if (le < MINLE)
                printf("A teljesitmeny min. %dLE legyen.\n", MINLE);
            else if (le > MAXLE)
                printf("A teljesitmeny max. %dLE legyen.\n", MAXLE);
            else {
                kw = letokw(le);
                ar = kwtoft(kw);
                osszeg+=ar;

                if (ar < min)
                    min = ar;

                if (ar > max)
                    max = ar;

                if (ar < KOZEPERTEK)
                    ++keves;

                if (ar > KOZEPERTEK)
                    ++sok;

                printf("Az jarmu teljesitmenye %.3fKw amire a bizositas %.2fFt.\n", kw, ar);

                ++bekert;
            }
        }

        if (bekert==MAXDB)
            printf("Bekertunk %d adatot, vege a bekeresnek\n");

    } while(!vege);

    if (bekert != 0) {
        printf("A biztositasok atlagara   : %.2fFt\n"
               "A bizositasok min. osszege: %.0fFt\n"
               "A bizositasok max. osszege: %.0fFt\n", osszeg/bekert, min, max);

        printf("%dFt -nal kevesebb: %ddb\n"
               "%dFt -nal tobb    : %ddb\n", KOZEPERTEK, keves, KOZEPERTEK, sok);
    } else {
        printf("Egy adatot sem adtak meg!\n");
    }

    getch();
}